Index: src/Actions/WorldAction/RepeatBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/RepeatBoxAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/RepeatBoxAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,16 +6,25 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/RepeatBoxAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
+#include "Box.hpp"
 
 #include <iostream>
 #include <string>
+#include <vector>
 
 using namespace std;
@@ -23,5 +32,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
 #include "Descriptors/MoleculePtrDescriptor.hpp"
@@ -36,6 +45,18 @@
 {}
 
+void WorldRepeatBox(Vector &Repeater) {
+  ValueStorage::getInstance().setCurrentValue(WorldRepeatBoxAction::NAME, Repeater);
+  ActionRegistry::getInstance().getActionByName(WorldRepeatBoxAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog * WorldRepeatBoxAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldRepeatBoxAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   Vector Repeater;
   int count;
@@ -46,6 +67,6 @@
   MoleculeListClass *molecules = World::getInstance().getMolecules();
 
-  dialog->queryVector(NAME, &Repeater, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription(NAME));
-  //dialog->queryMolecule("molecule-by-id", &mol,MapOfActions::getInstance().getDescription("molecule-by-id"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, Repeater);
+
   vector<molecule *> AllMolecules;
   if (mol != NULL) {
@@ -57,73 +78,67 @@
   }
 
-  if(dialog->display()) {
-    (cout << "Repeating box " << Repeater << " times for (x,y,z) axis." << endl);
-    double * const cell_size = World::getInstance().getDomain();
-    double *M = ReturnFullMatrixforSymmetric(cell_size);
-    Vector x,y;
-    int n[NDIM];
-    for (int axis = 0; axis < NDIM; axis++) {
-      Repeater[axis] = floor(Repeater[axis]);
-      if (Repeater[axis] < 1) {
-        DoeLog(1) && (eLog()<< Verbose(1) << "Repetition factor must be greater than 1!" << endl);
-        Repeater[axis] = 1;
-      }
-      cell_size[ ((axis == 1) ? 2 : (axis == 2) ? 5 : 0) ] *= Repeater[axis];
+  (cout << "Repeating box " << Repeater << " times for (x,y,z) axis." << endl);
+  Matrix M = World::getInstance().getDomain().getM();
+  Matrix newM = M;
+  Vector x,y;
+  int n[NDIM];
+  Matrix repMat;
+  for (int axis = 0; axis < NDIM; axis++) {
+    Repeater[axis] = floor(Repeater[axis]);
+    if (Repeater[axis] < 1) {
+      DoeLog(1) && (eLog()<< Verbose(1) << "Repetition factor must be greater than 1!" << endl);
+      Repeater[axis] = 1;
     }
+    repMat.at(axis,axis) = Repeater[axis];
+  }
+  newM *= repMat;
+  World::getInstance().setDomain(newM);
 
-    World::getInstance().setDomain(cell_size);
-    molecule *newmol = NULL;
-    Vector ** vectors = NULL;
-    for (n[0] = 0; n[0] < Repeater[0]; n[0]++) {
-      y[0] = n[0];
-      for (n[1] = 0; n[1] < Repeater[1]; n[1]++) {
-        y[1] = n[1];
-        for (n[2] = 0; n[2] < Repeater[2]; n[2]++) {
-          y[2] = n[2];
-          if ((n[0] == 0) && (n[1] == 0) && (n[2] == 0))
-            continue;
-          for (vector<molecule *>::iterator MolRunner = AllMolecules.begin(); MolRunner != AllMolecules.end(); ++MolRunner) {
-            mol = *MolRunner;
-            DoLog(1) && (Log() << Verbose(1) << "Current mol is " << mol->name << "." << endl);
-            count = mol->getAtomCount();   // is changed becausing of adding, thus has to be stored away beforehand
-            if (count != 0) {  // if there is more than none
-              Elements = new const element *[count];
-              vectors = new Vector *[count];
-              j = 0;
-              for(molecule::iterator AtomRunner = mol->begin(); AtomRunner != mol->end(); ++AtomRunner) {
-                Elements[j] = (*AtomRunner)->type;
-                vectors[j] = &(*AtomRunner)->x;
-                j++;
-              }
-              if (count != j)
-                DoeLog(1) && (eLog()<< Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl);
-              x = y;
-              x.MatrixMultiplication(M);
-              newmol = World::getInstance().createMolecule();
-              molecules->insert(newmol);
-              for (int k=count;k--;) { // go through every atom of the original cell
-                Walker = World::getInstance().createAtom(); // create a new body
-                Walker->x = (*vectors[k]) + x;
-                Walker->type = Elements[k];  // insert original element
-                cout << "new atom is " << *Walker << endl;
-                newmol->AddAtom(Walker);        // and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
-              }
-              // free memory
-              delete[](Elements);
-              delete[](vectors);
-            } else {
-              DoLog(1) && (Log() << Verbose(1) << "\t ... is empty." << endl);
+  molecule *newmol = NULL;
+  std::vector<Vector> vectors;
+  for (n[0] = 0; n[0] < Repeater[0]; n[0]++) {
+    y[0] = n[0];
+    for (n[1] = 0; n[1] < Repeater[1]; n[1]++) {
+      y[1] = n[1];
+      for (n[2] = 0; n[2] < Repeater[2]; n[2]++) {
+        y[2] = n[2];
+        if ((n[0] == 0) && (n[1] == 0) && (n[2] == 0))
+          continue;
+        for (vector<molecule *>::iterator MolRunner = AllMolecules.begin(); MolRunner != AllMolecules.end(); ++MolRunner) {
+          mol = *MolRunner;
+          DoLog(1) && (Log() << Verbose(1) << "Current mol is " << mol->name << "." << endl);
+          count = mol->getAtomCount();   // is changed becausing of adding, thus has to be stored away beforehand
+          if (count != 0) {  // if there is more than none
+            Elements = new const element *[count];
+            vectors.resize(count);
+            j = 0;
+            for(molecule::iterator AtomRunner = mol->begin(); AtomRunner != mol->end(); ++AtomRunner) {
+              Elements[j] = (*AtomRunner)->getType();
+              vectors[j] = (*AtomRunner)->getPosition();
+              j++;
             }
+            if (count != j)
+              DoeLog(1) && (eLog()<< Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl);
+            x = y;
+            x *= M;
+            newmol = World::getInstance().createMolecule();
+            molecules->insert(newmol);
+            for (int k=count;k--;) { // go through every atom of the original cell
+              Walker = World::getInstance().createAtom(); // create a new body
+              Walker->setPosition((vectors[k]) + x);
+              Walker->setType(Elements[k]);  // insert original element
+              cout << "new atom is " << *Walker << endl;
+              newmol->AddAtom(Walker);        // and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
+            }
+            // free memory
+            delete[](Elements);
+          } else {
+            DoLog(1) && (Log() << Verbose(1) << "\t ... is empty." << endl);
           }
         }
       }
     }
-    delete(M);
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
   }
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/RepeatBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/RepeatBoxAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/RepeatBoxAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,6 +10,11 @@
 
 #include "Actions/Action.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+void WorldRepeatBox(Vector &Repeater);
 
 class WorldRepeatBoxAction : public Action {
+  friend void WorldRepeatBox(Vector &Repeater);
+
 public:
   WorldRepeatBoxAction();
@@ -20,4 +25,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/ScaleBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/ScaleBoxAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/ScaleBoxAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,12 +6,20 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/ScaleBoxAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
+#include "Box.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 
 #include <iostream>
@@ -22,5 +30,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char WorldScaleBoxAction::NAME[] = "scale-box";
@@ -33,34 +41,41 @@
 {}
 
+void WorldScaleBox(Vector &Scaler) {
+  ValueStorage::getInstance().setCurrentValue(WorldScaleBoxAction::NAME, Scaler);
+  ActionRegistry::getInstance().getActionByName(WorldScaleBoxAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldScaleBoxAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldScaleBoxAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   Vector Scaler;
   double x[NDIM];
-  int j=0;
 
-  dialog->queryVector(NAME, &Scaler, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription(NAME));
+  ValueStorage::getInstance().queryCurrentValue(NAME, Scaler);
 
-  if(dialog->display()) {
-    DoLog(1) && (Log() << Verbose(1) << "Scaling all atomic positions by factor." << endl);
-    for (int i=0;i<NDIM;i++)
-      x[i] = Scaler[i];
-    vector<atom*> AllAtoms = World::getInstance().getAllAtoms();
-    for(vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner) {
-      (*AtomRunner)->x.ScaleAll(x);
-    }
-    j = -1;
-    double * const cell_size = World::getInstance().getDomain();
-    for (int i=0;i<NDIM;i++) {
-      j += i+1;
-      cell_size[j]*=x[i];
-    }
-    World::getInstance().setDomain(cell_size);
+  DoLog(1) && (Log() << Verbose(1) << "Scaling all atomic positions by factor." << endl);
+  for (int i=0;i<NDIM;i++)
+    x[i] = Scaler[i];
+  vector<atom*> AllAtoms = World::getInstance().getAllAtoms();
+  for(vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner) {
+    (*AtomRunner)->ScaleAll(x);
+  }
 
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
+  Matrix M = World::getInstance().getDomain().getM();
+  Matrix scale;
+
+  for (int i=0;i<NDIM;i++) {
+    scale.at(i,i) = x[i];
   }
+  M *= scale;
+  World::getInstance().setDomain(M);
+
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/ScaleBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/ScaleBoxAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/ScaleBoxAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,6 +10,11 @@
 
 #include "Actions/Action.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+void WorldScaleBox(Vector &Scaler);
 
 class WorldScaleBoxAction : public Action {
+  friend void WorldScaleBox(Vector &Scaler);
+
 public:
   WorldScaleBoxAction();
@@ -20,4 +25,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/SetDefaultNameAction.cpp
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/SetDefaultNameAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,9 +6,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/SetDefaultNameAction.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -20,5 +26,16 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class WorldSetDefaultNameState : public ActionState {
+public:
+  WorldSetDefaultNameState(std::string _lastName) :
+    lastName(_lastName)
+  {}
+  std::string lastName;
+};
 
 const char WorldSetDefaultNameAction::NAME[] = "default-molname";
@@ -31,42 +48,51 @@
 {}
 
+void WorldSetDefaultName(std::string &defaultname) {
+  ValueStorage::getInstance().setCurrentValue(WorldSetDefaultNameAction::NAME, defaultname);
+  ActionRegistry::getInstance().getActionByName(WorldSetDefaultNameAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldSetDefaultNameAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  string defaultname = World::getInstance().getDefaultName();
+  ValueStorage::getInstance().setCurrentValue(NAME, defaultname);
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldSetDefaultNameAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   string defaultname;
 
   defaultname = World::getInstance().getDefaultName();
-  dialog->queryString(NAME, &defaultname, MapOfActions::getInstance().getDescription(NAME));
+  WorldSetDefaultNameState *UndoState = new WorldSetDefaultNameState(defaultname);
+  ValueStorage::getInstance().queryCurrentValue(NAME, defaultname);
 
-  if(dialog->display()) {
-    World::getInstance().setDefaultName(defaultname);
-    DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << World::getInstance().getDefaultName() << "." << endl);
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  World::getInstance().setDefaultName(defaultname);
+  DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << World::getInstance().getDefaultName() << "." << endl);
+  return Action::state_ptr(UndoState);
 }
 
 Action::state_ptr WorldSetDefaultNameAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  WorldSetDefaultNameState *state = assert_cast<WorldSetDefaultNameState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  string newName = World::getInstance().getDefaultName();
+  World::getInstance().setDefaultName(state->lastName);
+  DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << World::getInstance().getDefaultName() << "." << endl);
+
+  return Action::state_ptr(new WorldSetDefaultNameState(newName));
 }
 
 Action::state_ptr WorldSetDefaultNameAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  return performUndo(_state);
 }
 
 bool WorldSetDefaultNameAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool WorldSetDefaultNameAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/WorldAction/SetDefaultNameAction.hpp
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/SetDefaultNameAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void WorldSetDefaultName(std::string &defaultname);
+
 class WorldSetDefaultNameAction : public Action {
+  friend void WorldSetDefaultName(std::string &defaultname);
+
 public:
   WorldSetDefaultNameAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/SetGaussianBasisAction.cpp
===================================================================
--- src/Actions/WorldAction/SetGaussianBasisAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/SetGaussianBasisAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,10 +6,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/SetGaussianBasisAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "config.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -21,5 +27,17 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class WorldSetGaussianBasisState : public ActionState {
+public:
+  WorldSetGaussianBasisState(std::string _lastName) :
+    lastName(_lastName)
+  {}
+  std::string lastName;
+};
+
 
 const char WorldSetGaussianBasisAction::NAME[] = "set-basis";
@@ -32,39 +50,47 @@
 {}
 
+void WorldSetGaussianBasis(std::string &basisname) {
+  ValueStorage::getInstance().setCurrentValue(WorldSetGaussianBasisAction::NAME, basisname);
+  ActionRegistry::getInstance().getActionByName(WorldSetGaussianBasisAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldSetGaussianBasisAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldSetGaussianBasisAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   config *configuration = World::getInstance().getConfig();
-  dialog->queryString(NAME, &(configuration->basis), MapOfActions::getInstance().getDescription(NAME));
 
-  if(dialog->display()) {
-    DoLog(1) && (Log() << Verbose(1) << "Setting MPQC basis to " << configuration->basis << "." << endl);
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  string lastname = configuration->basis;
+  ValueStorage::getInstance().queryCurrentValue(NAME, configuration->basis);
+
+  DoLog(1) && (Log() << Verbose(1) << "Setting MPQC basis to " << configuration->basis << "." << endl);
+  return Action::success;
 }
 
 Action::state_ptr WorldSetGaussianBasisAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  WorldSetGaussianBasisState *state = assert_cast<WorldSetGaussianBasisState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  config *configuration = World::getInstance().getConfig();
+  string newName = configuration->basis;
+  configuration->basis = state->lastName;
+
+  return Action::state_ptr(new WorldSetGaussianBasisState(newName));
 }
 
 Action::state_ptr WorldSetGaussianBasisAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  return performUndo(_state);
 }
 
 bool WorldSetGaussianBasisAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool WorldSetGaussianBasisAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/WorldAction/SetGaussianBasisAction.hpp
===================================================================
--- src/Actions/WorldAction/SetGaussianBasisAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/SetGaussianBasisAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void WorldSetGaussianBasis(std::string &basisname);
+
 class WorldSetGaussianBasisAction : public Action {
+  friend void WorldSetGaussianBasis(std::string &basisname);
+
 public:
   WorldSetGaussianBasisAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/SetOutputFormatsAction.cpp
===================================================================
--- src/Actions/WorldAction/SetOutputFormatsAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/SetOutputFormatsAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,11 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/SetOutputFormatsAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Parser/ChangeTracker.hpp"
 #include "Parser/FormatParserStorage.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -22,5 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char WorldSetOutputFormatsAction::NAME[] = "set-output";
@@ -33,35 +39,41 @@
 {}
 
+void WorldSetOutputFormats(vector<std::string> &FormatList) {
+  ValueStorage::getInstance().setCurrentValue(WorldSetOutputFormatsAction::NAME, FormatList);
+  ActionRegistry::getInstance().getActionByName(WorldSetOutputFormatsAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldSetOutputFormatsAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryStrings(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldSetOutputFormatsAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   vector<std::string> FormatList;
 
-  dialog->queryStrings(NAME, &FormatList, MapOfActions::getInstance().getDescription(NAME));
+  ValueStorage::getInstance().queryCurrentValue(NAME, FormatList);
 
-  if(dialog->display()) {
-    for (vector<std::string>::iterator iter = FormatList.begin(); iter != FormatList.end(); ++iter) {
-      if (*iter == "mpqc") {
-        FormatParserStorage::getInstance().addMpqc();
-        DoLog(0) && (Log() << Verbose(0) << "Adding mpqc type to output." << endl);
-      } else if (*iter == "pcp") {
-        FormatParserStorage::getInstance().addPcp();
-        DoLog(0) && (Log() << Verbose(0) << "Adding pcp type to output." << endl);
-      } else if (*iter == "tremolo") {
-        FormatParserStorage::getInstance().addTremolo();
-        DoLog(0) && (Log() << Verbose(0) << "Adding tremolo type to output." << endl);
-      } else if (*iter == "xyz") {
-        FormatParserStorage::getInstance().addXyz();
-        DoLog(0) && (Log() << Verbose(0) << "Adding xyz type to output." << endl);
-      } else {
-        DoeLog(1) && (eLog() << Verbose(1) << "Unknown format." << endl);
-      }
+  for (vector<std::string>::iterator iter = FormatList.begin(); iter != FormatList.end(); ++iter) {
+    if (*iter == "mpqc") {
+      FormatParserStorage::getInstance().addMpqc();
+      DoLog(0) && (Log() << Verbose(0) << "Adding mpqc type to output." << endl);
+    } else if (*iter == "pcp") {
+      FormatParserStorage::getInstance().addPcp();
+      DoLog(0) && (Log() << Verbose(0) << "Adding pcp type to output." << endl);
+    } else if (*iter == "tremolo") {
+      FormatParserStorage::getInstance().addTremolo();
+      DoLog(0) && (Log() << Verbose(0) << "Adding tremolo type to output." << endl);
+    } else if (*iter == "xyz") {
+      FormatParserStorage::getInstance().addXyz();
+      DoLog(0) && (Log() << Verbose(0) << "Adding xyz type to output." << endl);
+    } else {
+      DoeLog(1) && (eLog() << Verbose(1) << "Unknown format:" << *iter << endl);
     }
-    ChangeTracker::getInstance().saveStatus();
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
   }
+  ChangeTracker::getInstance().saveStatus();
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/SetOutputFormatsAction.hpp
===================================================================
--- src/Actions/WorldAction/SetOutputFormatsAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/SetOutputFormatsAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,11 @@
 #include "Actions/Action.hpp"
 
+#include <vector>
+
+void WorldSetOutputFormats(std::vector<std::string> &FormatList);
+
 class WorldSetOutputFormatsAction : public Action {
+  friend void WorldSetOutputFormats(std::vector<std::string> &FormatList);
+
 public:
   WorldSetOutputFormatsAction();
@@ -20,4 +26,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/AtomSet.hpp
===================================================================
--- src/AtomSet.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/AtomSet.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,91 @@
+/*
+ * AtomSet.hpp
+ *
+ *  Created on: Jul 30, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMSET_HPP_
+#define ATOMSET_HPP_
+
+
+#include <functional>
+#include <algorithm>
+#include <boost/foreach.hpp>
+#include <limits>
+
+/**
+ * A simple mixin to give any STL conforming structure fast Vector abilities
+ *
+ * TODO: make this work for maps
+ */
+
+#include "atom.hpp"
+#include <list>
+
+// this tests, whether we actually have a Vector
+template <class V>
+struct is_atom{};
+
+template <>
+struct is_atom<atom*>{
+  typedef void wrong_type;
+};
+
+template <class Set>
+class AtomSetMixin : public Set
+{
+  // when our set carries something besides a atom* this will produce an error
+  typedef typename is_atom<typename Set::value_type>::wrong_type check_for_atom;
+public:
+  // typedefs for STL conforming structure
+  typedef typename Set::iterator iterator;
+  typedef typename Set::const_iterator const_iterator;
+
+  AtomSetMixin() :
+    Set()
+  {}
+
+  AtomSetMixin(const Set& src) :
+    Set(src)
+  {}
+  virtual ~AtomSetMixin(){}
+
+  /**
+   * translate all Atoms within this set by a specified amount
+   */
+  void translate(const Vector &translater);
+
+  template<class Function>
+  void transformNodes(Function f);
+
+private:
+  template<class Function>
+  struct workOnNodePointer {
+    workOnNodePointer(Function &_f) : f(_f){}
+    void operator()(atom *atom){
+      atom->setPosition(f(atom->getPosition()));
+    }
+    Function &f;
+  };
+};
+
+template<class Set>
+inline void AtomSetMixin<Set>::translate(const Vector &translater){
+  BOOST_FOREACH(atom *atom,*this){
+    *(atom) += translater;
+  }
+}
+
+template<class Set>
+template<class Function>
+inline void AtomSetMixin<Set>::transformNodes(Function f){
+  std::for_each(this->begin(),
+                this->end(),
+                AtomSetMixin::workOnNodePointer<Function>(f));
+}
+
+// allows simpler definition of AtomSets
+#define ATOMSET(container_type) AtomSetMixin<container_type<atom*> >
+
+#endif /* ATOMSET_HPP_ */
Index: src/AtomicInfo.cpp
===================================================================
--- src/AtomicInfo.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/AtomicInfo.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,62 @@
+/*
+ * AtomicInfo.cpp
+ *
+ *  Created on: Aug 10, 2010
+ *      Author: heber
+ */
+
+#include "atom.hpp"
+#include "AtomicInfo.hpp"
+#include "element.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+/********************************** Functions for class AtomicInfo **********************************/
+
+AtomicInfo::AtomicInfo() :
+    Type(NULL),
+    Father(NULL),
+    Id(-1)
+{}
+AtomicInfo::AtomicInfo(const atom &_atom) :
+    Position(_atom.getPosition()),
+    Type(_atom.getType()),
+    Velocity(_atom.AtomicVelocity),
+    Father(_atom.father),
+    Mol(_atom.getMolecule()),
+    Id(_atom.getId())
+{}
+
+AtomicInfo::~AtomicInfo()
+{}
+
+
+bool AtomicInfo::setAtom(atom &_atom) const
+{
+  _atom.setPosition(Position);
+  _atom.setType(Type);
+  _atom.father = const_cast<atom *>(Father); // TODO: Actually, atom::father should be const atom *!
+  _atom.setMolecule(const_cast<molecule *>(Mol)); // this is ok, mol is const within AtomicInfo, but not outside (atoms need to register)
+  _atom.AtomicVelocity = Velocity;
+  if (_atom.getId() == Id)
+    return true;
+  else
+    return (_atom.changeId(Id));
+}
+
+atomId_t AtomicInfo::getId() const {
+  return Id;
+}
+
+AtomicInfo& AtomicInfo::operator=(const AtomicInfo& AI)
+{
+  if (&AI == this)  // check self-assignment
+    return *this;
+  Position = AI.Position;
+  Type = AI.Type;
+  Father = AI.Father;
+  Mol = AI.Mol;
+  Velocity = AI.Velocity;
+  Id = AI.Id;
+  return *this;
+}
+
Index: src/AtomicInfo.hpp
===================================================================
--- src/AtomicInfo.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/AtomicInfo.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,40 @@
+/*
+ * AtomicInfo.hpp
+ *
+ *  Created on: Aug 10, 2010
+ *      Author: heber
+ */
+
+#ifndef ATOMICINFO_HPP_
+#define ATOMICINFO_HPP_
+
+class atom;
+class element;
+class molecule;
+class Vector;
+
+/** This is for storing and transfering the information contained within an atom.
+ * This is needed for Undo/Redo operations of AtomActions.
+ */
+class AtomicInfo {
+public:
+  AtomicInfo();
+  AtomicInfo(const atom &_atom);
+  ~AtomicInfo();
+
+  bool setAtom(atom &_atom) const;
+  atomId_t getId() const;
+
+  AtomicInfo& operator=(const AtomicInfo&);
+
+private:
+  Vector Position;
+  const element * Type;
+  Vector Velocity;
+  const atom * Father;
+  const molecule * Mol;
+  atomId_t Id;
+};
+
+
+#endif /* ATOMICINFO_HPP_ */
